#include ".\ucos251\ucos251phyfl.h"
// application #includes, ...


// function prototypes for your tasks
void TaskStart(void *data) ; // startup task
void Task1(void *data) ;     // application task 1
void Task2(void *data) ;     // application task 2
// and so on ...


// a general error variable
INT8U ErrVar ;

// some variables required for dynamic memory allocations
OS_MEM *TaskStkArea ;        // memory partition handle for task stack area
INT8U *TaskStartStk ;        // stack bottom for TaskStart
INT8U *Task1Stk ;            // stack bottom for Task1
INT8U *Task2Stk ;            // stack bottom for Task2
// and so on ...


void main (void)
{
 OSInit() ;                  // initialize flashed uC/OS-II V2.51

 // create memory partition for task stacks and allocate stacks for several tasks ...
 TaskStkArea = OSMemCreate(TASK_STK_AREA, NUMOF_TASK_STKS, TASK_STK_SIZE, &ErrVar) ;
   // if (ErrVar != OS_NO_ERR) do some usefull error processing
 TaskStartStk = OSMemGet(TaskStkArea, &ErrVar) ;
   // if (ErrVar != OS_NO_ERR) do some usefull error processing
 Task1Stk = OSMemGet(TaskStkArea, &ErrVar) ;
   // if (ErrVar != OS_NO_ERR) do some usefull error processing
 Task2Stk = OSMemGet(TaskStkArea, &ErrVar) ;
   // if (ErrVar != OS_NO_ERR) do some usefull error processing

 // create highest priority (prio=0) start task
 ErrVar = OSTaskCreate(TaskStart, (void *)0, (void *)(TaskStartStk + TASK_TOS), 0);
   // if (ErrVar != OS_NO_ERR) do some usefull error processing

 // start multitasking
 OSStart();                                             
}


void TaskStart (void *data)
{
 data = data;         // prevent compiler warning, because data isn't used

 OSTickISRInit();     // Initialise System Tick ISR
 OSStatInit();        // Initialise uC/OS-II's statistics

 // create application tasks
 ErrVar = OSTaskCreate(Task1, (void *) 0, (void *)(Task1Stk + TASK_TOS), 4) ;
   // if (ErrVar != OS_NO_ERR) do some usefull error processing 
 ErrVar = OSTaskCreate(Task2, (void *) 0, (void *)(Task2Stk + TASK_TOS), 5) ;
   // if (ErrVar != OS_NO_ERR) do some usefull error processing 

 // task loop, for example ...
 while (1) {
   access_OSCtxSwCtr = 0 ;     // reset context switch counter
   OSTimeDlyHMSM(0, 0, 1, 0 ); // wait 1 seconds
 }
}


void Task1 (void *data)
{
 data = data ; // prevent compiler warning

 // things to do only once per task

 // task loop
 while (1) {

   // the task's main function

   }
}


void Task2 (void *data)
{
 data = data ; // prevent compiler warning

 // things to do only once per task

 // task loop
 while (1) {

   // the task's main function

   }
}

