/*
*********************************************************************************************************
*                                                uC/OS-II
*                                          The Real-Time Kernel
*
*                          (c) Copyright 1992-1999, Jean J. Labrosse, Weston, FL
*                                           All Rights Reserved
*
*                            uC/OS-II V2.51 flashed on Phytec SK-C167CR Board
*                      Interface to OS global variables, Memory Partition Information
*                                   Peter Balog, 8th of July 2001
*********************************************************************************************************
*/

#if     !defined(_ucos251phyfl_ifc)
#define _ucos251phyfl_ifc

// macros to access global OS variables
#define access_OSCPUUsage        *(INT8S *)                             0x537C
#define access_OSCtxSwCtr        *(INT32U *)                            0x4668
#define access_OSEventFreeList    (OS_EVENT *)                          0x4464
#define access_OSEventTbl         (OS_EVENT[OS_MAX_EVENTS])             0x4468
#define access_OSFlagFreeList     (OS_FLAG_GRP *)                       0x46AC
#define access_OSFlagTbl          (OS_FLAG_GRP[OS_MAX_FLAGS])           0x466C
#define access_OSIdleCtr         *(INT32U *)                            0x4460
#define access_OSIdleCtrMax      *(INT32U *)                            0x4008
#define access_OSIdleCtrRun      *(INT32U *)                            0x5370
#define access_OSIntExitY        *(INT8U *)                             0x5378
#define access_OSIntNesting      *(INT8U *)                             0x5379
#define access_OSLockNesting     *(INT8U *)                             0x537A
#define access_OSMemFreeList      (OS_MEM *)                            0x440C
#define access_OSMemTbl           (OS_MEM[OS_MAX_MEM_PART])             0x4410
#define access_OSPrioCur         *(INT8U *)                             0x5376
#define access_OSPrioHighRdy     *(INT8U *)                             0x5374
#define access_OSQFreeList        (OS_Q *)                              0x4EAC
#define access_OSQTbl             (OS_Q[OS_MAX_QS])                     0x4EB0
#define access_OSRdyGrp          *(INT8U *)                             0x537D
#define access_OSRdyTbl           (INT8U[OS_RDY_TBL_SIZE])              0x4000
#define access_OSRunning         *(BOOLEAN)                             0x537B
#define access_OSStatRdy         *(BOOLEAN)                             0x5375
#define access_OSTCBCur           (OS_TCB *)                            0x47B8
#define access_OSTCBFreeList      (OS_TCB *)                            0x47BC
#define access_OSTCBHighRdy       (OS_TCB *)                            0x47B4
#define access_OSTCBList          (OS_TCB *)                            0x4EA8
#define access_OSTCBPrioTbl       (OS_TCB[OS_LOWEST_PRIO+1])            0x46B0
#define access_OSTCBTbl           (OS_TCB[OS_MAX_TASKS+OS_N_SYS_TASKS]) 0x47C0
#define access_OSTaskCtr         *(INT8U *)                             0x5377
#define access_OSTaskIdleStk      (OS_STK[OS_TASK_IDLE_STK_SIZE])       0x400C
#define access_OSTaskStatStk      (OS_STK[OS_TASK_STAT_STK_SIZE])       0x4F70
#define access_OSTime            *(INT32U *)                            0x47B0




// up to 4 memory partitions can be defined within 24kB address space (0x8000-0xDFFF)
// to be managed by OSMemXXX

// ram from 0x8000-0xBFFF (16 kB) reserved for task stacks (!!! DON'T CHANGE THIS PARTITION !!!)
#define TASK_STK_AREA      0x8000
#define NUMOF_TASK_STKS    32
#define TASK_STK_SIZE      256*sizeof(OS_STK)
#define TASK_TOS           TASK_STK_SIZE-2
#define TASK_STK_AREA_TOP  TASK_STK_AREA+(NUMOF_TASK_STKS*TASK_STK_SIZE)

// ram from 0xC000-0xDFFF (8 kB) can be used for other sized memory blocks (you may change this partiton)
// MEM32_AREA defines 32 pieces of 32 byte memory chunks (1kB, 0xC000-0xC3FF)
#define MEM32_AREA        TASK_STK_AREA_TOP
#define NUMOF_MEM32S      32
#define MEM32_SIZE        32
#define MEM32_AREA_TOP    MEM32_AREA+(NUMOF_MEM32S*MEM32_SIZE)

// ... continue with 3rd memory partition
// ... continue with 4th memory partition



#endif
